apiVersion: apps/v1 #apps is the most common API group in Kubernetes, with many core objects being drawn from it and v1.
# It includes functionality related to running applications on Kubernetes, like Deployments, RollingUpdates, and ReplicaSets.
kind: Deployment # The Resource type see https://kubernetes.io/docs/concepts/workloads/controllers/deployment/
metadata:
  name: gui-app-deployment # Name of the resource
  labels:
    app: gui-app
spec:
  replicas: 2 # number of pods to run
  selector:
    matchLabels:
      app: gui-app
  template:
    metadata:
      labels:
        app: gui-app
    spec:
      containers:
        - name: gui-app
          image: "FULL_REPOSITORY_NAME" #this should always be "FULL_REPOSITORY_NAME", it will be replaced by the deployment scripts
          ports:
            - containerPort: 5000 # container port
---
apiVersion: v1
kind: Service # see https://kubernetes.io/docs/concepts/services-networking/service/
metadata:
  name: gui-app # name of the resource, connects with endpoints
  labels:
    app: gui-app
spec:
  ports:
    - port: 5000 # service port
      name: http
  selector:
    app: gui-app # seach space for pods to include in the service